;Model file S2: NONMEM model file of the full model

$SIZES NO=-10000 PD=-5000 LVR=50 PC=35

$PROBLEM COVID-19 full model

$INPUT ID Week Year STATE=DROP TIME TIME2 DROP DV LNDV LNDVCR OBS CMT AMT EVID MDV NUMBER CASE0 ICUDATASET DIVIFLAG SCHOOLS STORECLOSURE CURFEW RESTRAININGORDER CARNIVAL FLAGZEROOBS FLAGRKI FLAGMP DOSING2 MAXIMUMICU FLAG20200714 MDV20200714 FLAG20200804 RKIDEATHS MPCASES MPCASESRECOVRKIDEATH Zweitimpfungen secondDosesCumulative tglImpfungen Datenende LastTimeImpfungen CumTglImpfungen A00toA04_M A00toA04_W A05toA14_M A05toA14_W A15toA34_M A15toA34_W A35toA59_M A35toA59_W A60toA79_M A60toA79_W A80_M A80_W PositiveRate numberTests PREDIC fixRt_0 fixRt_1 fixRt_2 fixRt_3 fixRt_4 fixRt_5 fixRt_6 fixRt_7 fixRt_8 fixRt_9 fixRt_10 fixRt_11 fixRt_12 fixRt_13 fixRt_14 fixRt_15 fixRt_16 fixRt_17 fixRt_18 fixRt_19 fixRt_20 fixRt_21 fixRt_22 fixRt_23 fixRt_24 fixRt_25 fixCP_4 fixCP_5 fixCP_6 fixCP_7 fixCP_8 fixCP_9 fixCP_10 fixCP_11 fixCP_12 fixCP_13 fixCP_14 fixCP_15 fixCP_16 fixCP_17 fixCP_18 fixCP_19 fixCP_20 fixCP_21 fixCP_22 fixCP_23 fixCP_24 fixCP_25 fixF2 MDVLAST
$DATA DATASET.csv IGNORE=@ IGNORE(CMT.EQ.4) IGNORE(DOSING2.EQ.1) IGNORE(DIVIFLAG.EQ.2) IGNORE(CMT.EQ.8) IGNORE(CMT.EQ.11) IGNORE(CMT.EQ.12) IGNORE(CMT.EQ.9) IGNORE(FLAGZEROOBS.EQ.1) IGNORE(ID.EQ.17) IGNORE(FLAGRKI.EQ.1) IGNORE(PREDIC.EQ.1) IGNORE(TIME.GT.466)

$SUBROUTINES ADVAN6 TOL=6
$MODEL NCOMPS=30

$PK
;Parameters for infectious model
Q_0 = 0
A_0(1) = NUMBER
RtSTART = fixRt_0
COV1 = SCHOOLS
E1 = fixRt_1
COV2 = CARNIVAL
E2 = fixRt_2
COV3 = MAX(CURFEW,RESTRAININGORDER)
E3 = fixRt_3
MTDIFF = 1
MTIME(1) = fixCP_4
COV4 = MPAST(1)
E4 = fixRt_4
MTIME(2) = fixCP_5
COV5 = MPAST(2)
E5 = fixRt_5
MTIME(3) = fixCP_6
COV6 = MPAST(3)
E6 = fixRt_6
MTIME(4) = fixCP_7
COV7 = MPAST(4)
E7 = fixRt_7
MTIME(7) = fixCP_8
COV8 = MPAST(7)
E8 = fixRt_8
MTIME(8) = fixCP_9
COV9 = MPAST(8)
E9 = fixRt_9
MTIME(9) = fixCP_10
COV10 = MPAST(9)
E10 = fixRt_10
MTIME(11) = fixCP_11
COV11 = MPAST(11)
E11 =fixRt_11
MTIME(12) = fixCP_12
COV12 = MPAST(12)
E12 = fixRt_12
MTIME(13) = fixCP_13
COV13 = MPAST(13)
E13 = fixRt_13
MTIME(14) = fixCP_14
COV14 = MPAST(14)
E14 = fixRt_14
MTIME(16) = fixCP_15
COV15 = MPAST(16)
E15= fixRt_15
MTIME(17) = fixCP_16
COV16= MPAST(17)
E16= fixRt_16
MTIME(18) = fixCP_17
COV17= MPAST(18)
E17= fixRt_17
MTIME(19) = fixCP_18
COV18= MPAST(19)
E18= fixRt_18
MTIME(20) = fixCP_19
COV19= MPAST(20)
E19= fixRt_19
MTIME(21) = fixCP_20
COV20 = MPAST(21)
E20= fixRt_20
MTIME(22) = fixCP_21
COV21 = MPAST(22)
E21 = fixRt_21
MTIME(23) = fixCP_22
COV22 = MPAST(23)
E22 = fixRt_22
MTIME(24) = fixCP_23
COV23 = MPAST(24)
E23 = fixRt_23
MTIME(25) = fixCP_24
COV24 = MPAST(25)
E24 = fixRt_24
MTIME(26) = fixCP_25
COV25 = MPAST(26)
E25= fixRt_25
MTIME(26) = fixCP_25
COV25 = MPAST(26)
E25= fixRt_25

RtFREE_OLD = RtSTART*(1-COV1)+E2*COV2+E1*(COV1-COV3)+E3*(COV3-COV4)+E4*(COV4-COV5)+E5*(COV5-COV6)+E6*(COV6-COV7)+E7*(COV7-COV8)+E8*(COV8-COV9)+E9*(COV9-COV10)+E10*(COV10-COV11)+E11*(COV11-COV12)+E12*(COV12-COV13)+E13*(COV13-COV14)+E14*(COV14-COV15)+E15*(COV15-COV16)+E16*(COV16-COV17)+E17*(COV17-COV18)+E18*(COV18-COV19)+E19*(COV19-COV20)+E20*(COV20-COV21)+E21*(COV21-COV22)+E22*(COV22-COV23)+E23*(COV23-COV24)+E24*(COV24-COV25)+E25*COV25

F2 = fixF2
ALAG2 = 9

isolation = 100
infectious = 7

gamma = 1/(infectious)

PR= PositiveRate
IF(PositiveRate.LT.0.1) PR=0.1

;VOC Alpha model parameters
InitDay = 347
k=0.072
initVOC=0.002
DSM = TIME-InitDay 
IF(TIME.LT.InitDay) DSM = 0
FractionVOC = 1/(1+((1-initVOC)/initVOC)*EXP(-k*DSM))

;time until discharge, proportion of time on ICU and on a mechanical ventilator as extracted of clinical database
IIV1 = EXP(ETA(1))
hill1 = THETA(14)
F_LD_VENT_L = THETA(2)-(THETA(2)*THETA(3))*TIME**hill1/(TIME**hill1+THETA(15)**hill1)
LD_VENT_D = 15.5                    ;Duration until discharge ICU with ventilation death
LD_VENT_L = 28.6*F_LD_VENT_L        ;Duration until discharge ICU with ventilation recovery
LD_ICU_D = 20                       ;Duration until discharge ICU without ventilation death
LD_ICU_L = 20.4                     ;Duration until discharge ICU without ventilation recovery
LD_HOSP_D = 10.6                    ;Duration until discharge general ward only death
LD_HOSP_L = 11.5                    ;Duration until discharge general ward only recovery
P_VENT_STAY_D = 0.63                ;Proportion of time ventilated of ICU with ventilation death
P_VENT_STAY_L = 0.28                ;Proportion of time ventilated of ICU with ventilation recovery
P_VENT_on_ICU_STAY_D = 0.68         ;Proportion of time on ICU of ICU with ventilation death
P_VENT_on_ICU_STAY_L = 0.43         ;Proportion of time on ICU of ICU with ventilation recovery
P_ICU_STAY_D = 0.44                 ;Proportion of time on ICU of ICU without ventilation death
P_ICU_STAY_L = 0.29                 ;Proportion of time on ICU of ICU without ventilation recovery

;Correction factors for federal states with different reporting
fBER = 1
IF(ID.EQ.3) fBER = THETA(8)
fHE = 1
IF(ID.EQ.7) fHE = 1.15
fBR = 1
IF(ID.EQ.5) fBR = 1.3
fHH = 1
IF(ID.EQ.6) fHH = 1.2

;Hospitalized fractions by age group, corrected by factor 
Hosp80= THETA(1)
Hosp60= 0.578*THETA(1)
Hosp0 = 0.0735*THETA(1)
Hosp5 = 0.0178*THETA(1)
Hosp15= 0.0305*THETA(1)
Hosp35= 0.148*THETA(1)

;Hospitalized fractions by age, sex and time
H0 = Hosp0*(A00toA04_M+A00toA04_W*0.817)
H5 = Hosp5*(A05toA14_M+A05toA14_W)
H15 = Hosp15*(A15toA34_M+A15toA34_W*1.55)
H35 = Hosp35*(A35toA59_M+A35toA59_W*0.597)
H60 = Hosp60*(A60toA79_M+A60toA79_W*0.708)
H80 = Hosp80*(A80_M+A80_W*0.588)

;Covariate impact and changes of hospitalization rate
MTIME(15) = THETA(10)
FHOSP = THETA(5)
hill2 = THETA(22)
FHOSPnTEST = THETA(11)    

hosptrans = THETA(10)
hosp_TV = H0+H5+H15+H35+H60+H80
hospfactor = (1-FHOSP*TIME**hill2/(THETA(4)**hill2+TIME**hill2))*EXP(-FHOSPnTEST*numberTests/1000000)*(1+FractionVOC*THETA(20))
hosp = hosp_TV*hospfactor
isolated = (1-hosp)*isolation
hospitalized = hosp*isolation

;Fraction treated at ICU
POP1 = 0
POP2 = 0
IF(ID.EQ.2) POP1 = 1
IF(ID.EQ.3) POP1 = 1
IF(ID.EQ.5) POP1 = 1
IF(ID.EQ.6) POP1 = 1
IF(ID.EQ.7) POP1 = 1
IF(ID.EQ.10) POP1 = 1
IF(ID.EQ.12) POP1 = 1
IF(ID.EQ.17) POP2 = 1
FICU= (THETA(6)+(POP1*THETA(13)+(1-POP1)*THETA(24)+POP2*THETA(25))*TIME**hill2/(THETA(4)**hill2+TIME**hill2))*(1+FractionVOC*THETA(21))

ICU0 = Hosp0*(A00toA04_M+A00toA04_W*0.817*0.255)*0.439*FICU/hosp_TV
ICU5 = Hosp5*(A05toA14_M+A05toA14_W*0.299)*0.363*FICU/hosp_TV
ICU15 = Hosp15*(A15toA34_M+A15toA34_W*1.55*0.435)*0.41*FICU/hosp_TV
ICU35 = Hosp35*(A35toA59_M+A35toA59_W*0.597*0.600)*0.66*FICU/hosp_TV
ICU60 = Hosp60*(A60toA79_M+A60toA79_W*0.708*0.652)*FICU/hosp_TV
ICU80 = Hosp80*(A80_M+A80_W*0.588*0.608)*0.65*FICU/hosp_TV

revFRACTHOSP =(ICU0+ICU5+ICU15+ICU35+ICU60+ICU80)
FRACTHOSP = 1-revFRACTHOSP
toHOSP =  hosptrans*FRACTHOSP

;Fraction ICU (ventilated)
B0 = ICU0/revFRACTHOSP*0.308
B5 = ICU5/revFRACTHOSP*0.444
B15 = ICU15/revFRACTHOSP*0.463
B35 = ICU35/revFRACTHOSP*0.600
B60 = ICU60/revFRACTHOSP*0.719
B80 = ICU80/revFRACTHOSP*0.666
FRACTVENT = (B0+B5+B15+B35+B60+B80)
FRACTICU = 1-FRACTVENT
toICU = hosptrans*(1-FRACTHOSP)*FRACTICU
toVENT = hosptrans*(1-FRACTHOSP)*(1-FRACTICU)

;Proportion of patients at respective wards and of respective age and sex calculated for death
HOSPu60_M = (1-0.66*FICU)*(Hosp35*A35toA59_M)/hosp_TV/FRACTHOSP
HOSPo60_M = (1-FICU)*(Hosp60*A60toA79_M)/hosp_TV/FRACTHOSP
HOSPo80_M = (1-0.65*FICU)*(Hosp80*A80_M)/hosp_TV/FRACTHOSP
HOSPu60_W = (1-0.600*0.66*FICU)*(Hosp35*A35toA59_W*0.597)/hosp_TV/FRACTHOSP
HOSPo60_W = (1-0.652*FICU)*(Hosp60*A60toA79_W*0.708)/hosp_TV/FRACTHOSP
HOSPo80_W = (1-0.608*0.65*FICU)*(Hosp80*A80_W*0.588)/hosp_TV/FRACTHOSP
ICUo35 = ICU35*(1-0.6)/revFRACTHOSP/FRACTICU
ICUo60 = ICU60*(1-0.719)/revFRACTHOSP/FRACTICU
ICUo80 = ICU80*(1-0.666)/revFRACTHOSP/FRACTICU
Bo05 = (B5)/(FRACTVENT+0.001)
Bo15 = (B15)/(FRACTVENT+0.001)
Bo35 = (B35)/(FRACTVENT+0.001)
Bo60 = (B60)/(FRACTVENT+0.001)
Bo80 = (B80)/(FRACTVENT+0.001)

;Death rates inpatients
PRdeath = (THETA(7)-THETA(7)*THETA(12)*EXP(-PR*THETA(9)))
PRdeathICU = (THETA(7)-THETA(7)*THETA(12)*EXP(-3.12*THETA(9)))
HOSPd = (0.0125*HOSPu60_M+0.0125*HOSPu60_W+0.147*HOSPo60_M+0.101*HOSPo60_W+0.414*HOSPo80_M+0.334*HOSPo80_W)*(1+FractionVOC*THETA(19))*PRdeath
ICUd = (0.0453*ICUo35+0.193*ICUo60+0.477*ICUo80) *(1+FractionVOC*THETA(19))*PRdeathICU
VENTd = (0.25*Bo05+0.18*Bo15+0.372*Bo35+0.653*Bo60+0.841*Bo80) *(1+FractionVOC*THETA(19))*PRdeathICU

;Death rates outpatient
MTIME(10) = THETA(18)
hill3 = THETA(23)
FDOUT = THETA(17)*TIME**hill3/(TIME**hill3+THETA(18)**hill3)
FDOUT2 = THETA(26)*THETA(17)*TIME**hill3/(TIME**hill3+THETA(27)**hill3)
RR_Death = 0.16 
out80M = A80_M*(1-Hosp80*hospfactor)
out80W = A80_W*(1-Hosp80*0.588*hospfactor)
out60M = A60toA79_M*(1-Hosp60*hospfactor)
out60W = A60toA79_W*(1-Hosp60*0.708*hospfactor)
OUTd = (THETA(16)+FDOUT-FDOUT2)*PRdeath*(1+FractionVOC*THETA(19))
death = (out80M+out80W*0.334/0.414+(out60M+out60W*0.101/0.147)*1.22/10.1)/(1-hosp)*OUTd  

;transit rates for different wards and outcomes
deathHOSP = 2/(LD_HOSP_D)
deathICU = 2/(LD_ICU_D)
deathVENT = 2/(LD_VENT_D)
recovery_rateHOSP = 2/(LD_HOSP_L)
recovery_rateICU = 2/(LD_ICU_L)
recovery_rateVENT = 2/(LD_VENT_L)

MTIME(5) = 70
REC_TIME = MPAST(5)
recovery = 14
recovery_rate = 2/recovery
recovery_hosp = 14
recovery_ratehosp = 2/recovery_hosp
death_rate = 2/LD_HOSP_D

HOSPl = 1-HOSPd
ICUl = 1-ICUd
VENTl = 1-VENTd

$DES
DaysSinceVOC = T-InitDay
IF(T.LT.InitDay) DaysSinceVOC = 0
VOC = 1/(1+((1-initVOC)/initVOC)*EXP(-k*DaysSinceVOC))
IF(T.LT.InitDay) VOC = 0
RtFREE = RtFREE_OLD*(1-VOC)+RtFREE_OLD*1.35*VOC
beta = RtFREE*gamma
DADT(1) = -beta*A(1)/NUMBER*A(2)                                    ;S
DADT(2) = beta*A(1)/NUMBER*A(2) -  gamma*A(2)                       ;I
DADT(3) = gamma*A(2) - isolated*A(3) - hospitalized*A(3)            ;A
DADT(4) = isolated*A(3)*(1-death) - recovery_rate*A(4) 	            ;QR1 
DADT(5) = HOSPl*toHOSP*A(26) - recovery_rateHOSP*A(5) 				;Halive1
DADT(6) = recovery_rateHOSP*A(5) - recovery_rateHOSP*A(6)			;Halive2
DADT(7) = HOSPd*toHOSP*A(26)- deathHOSP*A(7) 						;Hdeath1
DADT(8) = deathHOSP*A(7) - deathHOSP*A(8) 							;Hdeath2
DADT(9) = ICUl*toICU*A(26) - recovery_rateICU*A(9) 					;ICUalive1
DADT(10) = recovery_rateICU*A(9) - recovery_rateICU*A(10) 			;ICUalive2
DADT(11) = ICUd*toICU*A(26)- deathICU*A(11) 						;ICUdeath1
DADT(12) = deathICU*A(11)- deathICU*A(12) 							;ICUdeath2
DADT(13) = VENTl*toVENT*A(26) - recovery_rateVENT*A(13) 			;Valive1
DADT(14) = recovery_rateVENT*A(13) - recovery_rateVENT*A(14) 		;Valive2
DADT(15) = VENTd*toVENT*A(26) - deathVENT*A(15) 					;Vdeath1
DADT(16) = deathVENT*A(15)- deathVENT*A(16) 						;Vdeath2
DADT(17) = recovery_rate*A(20) +  recovery_ratehosp*A(24)           ;R
DADT(18) = death_rate*A(29) +deathHOSP*A(8) + deathICU*A(12) + deathVENT*A(16);D daily
DADT(19) = gamma*A(2)                                               ;total cases
DADT(20) = recovery_rate*A(4) - recovery_rate*A(20)                 ;QR2
DADT(21) = (toICU + toVENT + toHOSP)*A(26)                          ;daily hospitalizations
DADT(22) = (toICU + toVENT)*A(26)                                   ;daily ICU patients
DADT(23) = recovery_rateHOSP*A(6) + recovery_rateICU*A(10) + recovery_rateVENT*A(14) - recovery_ratehosp*A(23) ;R1hospital
DADT(24) = recovery_ratehosp*A(23) - recovery_ratehosp*A(24)        ;R2hospital
DADT(25) = hospitalized*A(3) - hosptrans*A(25)                      ;T1hosp
DADT(26) = hosptrans*A(25) - hosptrans*A(26)                        ;T2hosp
DADT(27) = death_rate*A(29) +deathHOSP*A(8) + deathICU*A(12) + deathVENT*A(16);D
DADT(28) = isolated*A(3)*death - death_rate*A(28)                   ;QD1
DADT(29) = death_rate*A(28) - death_rate*A(29)                      ;QD2

$ERROR
DaysSinceVOC_Err = TIME-InitDay
IF(TIME.LT.InitDay) DaysSinceVOC_Err = 0
VOC_Err = 1/(1+((1-initVOC)/initVOC)*EXP(-k*DaysSinceVOC_Err))
IF(TIME.LT.InitDay) VOC_Err = 0
RtFREE_Err = RtFREE_OLD*(1-VOC_Err)+RtFREE_OLD*1.35*VOC_Err
Rt = RtFREE_Err*A(1)/NUMBER
CASES = A(19)+Q_0
VENTILATED = P_VENT_STAY_L*(A(13)+A(14))+P_VENT_STAY_D*(A(15)+A(16))
VENTILATED_ABS = VENTILATED
VENTILATED_ICU = P_VENT_on_ICU_STAY_L*(A(13)+A(14))+P_VENT_on_ICU_STAY_D*(A(15)+A(16))
ICUtotal = P_ICU_STAY_L*(A(9)+A(10))+ P_ICU_STAY_D*(A(11)+A(12))+VENTILATED_ICU
ICU_ABS = ICUtotal
HOSPtotal = A(5)+A(6)+A(7)+A(8)+A(9)+A(10)+A(11)+A(12)+A(13)+A(14)+A(15)+A(16)
DAILY_DEAD = A(18)
DAILY_HOSP = A(21)
DEAD = A(27)
RECOVERED = CASE0+Q_0+A(17)*REC_TIME

IPRED = CASES
IF(CMT.EQ.4) IPRED = RECOVERED 
IF(CMT.EQ.5) IPRED = ICU_ABS*fBER*fBR*fHH
IF(CMT.EQ.6) IPRED = DEAD
IF(CMT.EQ.7) IPRED = HOSPtotal*fBER*fHE
IF(CMT.EQ.10) IPRED = VENTILATED_ABS*fBER*fBR*fHH
IF(CMT.EQ.18) IPRED = DAILY_DEAD
IF(CMT.EQ.21) IPRED = DAILY_HOSP
W = IPRED
DEL = 0
IF(IPRED.EQ.0) DEL = 0.001
IRES	= DV -  IPRED
IWRES   = IRES/(W+DEL)
Y  = IPRED *EXP(EPS(1)) + EPS(2)                ;cases
IF(CMT.EQ.5) Y = IPRED + W*EPS(3) + EPS(4)      ;ICU
IF(CMT.EQ.6) Y = IPRED + W*EPS(5)  + EPS(6)     ;death
IF(CMT.EQ.7) Y = IPRED + W*EPS(7) + EPS(8)      ;hospital
IF(CMT.EQ.10) Y = IPRED + W*EPS(9)  + EPS(10)   ;ventilated
IF(CMT.EQ.18) Y = IPRED + W*EPS(11) + EPS(12)   ;daily deaths
IF(CMT.EQ.21) Y = IPRED + W*EPS(13) + EPS(14)   ;daily hospitalizations

$THETA
(0.8, 0.999,1) FIX ;1 hosp80
(1, 1.69,2)  ;2 ftoVENT1
(0, 0.648,1)  ;3 factor ftoVENT2
(50, 281,400)  ;4 MTHOSP
(0.1, 0.496,1)  ;5 fHOSP
(0, 0.476,1)  ;6 toICU 
(0.5, 1.05,1.7)  ;7 fdeath
(0.3, 1.52,2) FIX ;8 fBER
(0, 0.129)  ;9 PR death
(100) FIX ; 10 hosptrans
(0, 0.334)  ;11 FHOSPnTEST
(0, 0.48,1)  ;12 fmin PR Death
(0, 0.29,1)  ;13 +toICU POP1
(100) FIX ;14 hill1 vent
(50, 228,350)  ;15 MTICU
0 FIX  ;16 dout
(0, 0.226,1)  ;17 dout2
(0, 348,450)  ;18 MTIME FDOUT
0 FIX ;19 factor D VOC
(0, 0.395,1)  ;20 factor H VOC
(0, 0.162,1)  ;21 factor ICU VOC
(100) FIX ;22 hill2 hosp+ICU
(0, 29.57,100)  ;23 hill3 dout
(-0.2, 0.0904,1)  ;24 +toICU 1-POP1
(-0.2, 0.136,1) FIX;25 +toICU Germany
1 FIX; 26 Fraction -FDOUT
(360,446, 500);27 MTIME FDOUT2

$OMEGA 
 0 FIX  ;1 dummy IIV

$SIGMA 
 0.000032 ;prop ccases
 1060 ;add cases
 0.0544 ;prop icu
 20.8 ;add icu
 0.00957 ;prop death
 140 ;add death
 0.124 ;prop hospital
 175 ;add hospital
 0.0884 ;prop ventilated
 2.19 ;add ventilated
 0.647 ;prop daily death
 0.13 ;add daily death
 6.82 ;prop daily hospitalizations
 2.12 ;add dkdaily hospitalizations

$EST METHOD=1 INTER MAXEVAL=9999 NOABORT NSIG=3 SIGL=6 PRINT=1 POSTHOC
$COV UNCOND MATRIX=R

$TABLE ID TIME DV OBS CMT EVID MDV IPRED DIVIFLAG Rt RtFREE RtFREE_OLD hosp FRACTHOSP FRACTICU HOSPd ICUd VENTd OUTd death ONEHEADER NOPRINT FILE=sdtab2101i
